
Ruby - Bug #21318

Namespaces leak with Module.nesting

05/09/2025 10:54 PM - fxn (Xavier Noria)

Status: Open   

Priority: Normal   

Assignee:    

Target version:    

ruby -v:  Backport: 3.2: UNKNOWN, 3.3: UNKNOWN, 3.4:

UNKNOWN

Description

Namespaces are not transparent for this program:

Module.nesting

 The nesting is empty or not depending on whether it is being executed under a namespace.

History

#1 - 05/09/2025 10:57 PM - fxn (Xavier Noria)

- Subject changed from Namespaces leak with permanent names to Namespaces leak with Module.nesting

#2 - 05/10/2025 11:06 AM - Eregon (Benoit Daloze)

Complete reproducer:

$ RUBY_NAMESPACE=1 ruby -ve 'p Module.nesting; ns = Namespace.new; File.write "ns.rb", "p Module.nesting"; ns.

require "./ns"'

ruby 3.5.0dev (2025-05-10T07:50:29Z namespace-on-read-.. bd4f57f96b) +PRISM [x86_64-linux]

ruby: warning: Namespace is experimental, and the behavior may change in the future!

See doc/namespace.md for know issues, etc.

[]

[#<Namespace:24,user,optional>]

#3 - 06/03/2025 05:48 AM - hsbt (Hiroshi SHIBATA)

- Tags set to namespace
